;;; $DOOMDIR/config.el -*- lexical-binding: t; -*-

;; Place your private configuration here! Remember, you do not need to run 'doom
;; sync' after modifying this file!


;; Some functionality uses this to identify you, e.g. GPG configuration, email
;; clients, file templates and snippets.
(setq user-full-name "Sanchayan Maity"
      user-mail-address "maitysanchayan@gmail.com")

;; Doom exposes five (optional) variables for controlling fonts in Doom. Here
;; are the three important ones:
;;
;; + `doom-font'
;; + `doom-variable-pitch-font'
;; + `doom-big-font' -- used for `doom-big-font-mode'; use this for
;;   presentations or streaming.
;;
;; They all accept either a font-spec, font string ("Input Mono-12"), or xlfd
;; font string. You generally only need these two:
(setq doom-font (font-spec :family "JetBrainsMono Nerd Font" :size 20))

;; There are two ways to load a theme. Both assume the theme is installed and
;; available. You can either set `doom-theme' or manually load a theme with the
;; `load-theme' function. This is the default:
(setq doom-theme 'doom-vibrant)

;; If you use `org' and don't want your org files in the default location below,
;; change `org-directory'. It must be set before org loads!
(setq org-directory "~/org/")

;; This determines the style of line numbers in effect. If set to `nil', line
;; numbers are disabled. For relative line numbers, set this to `relative'.
(setq display-line-numbers-type t)


;; Here are some additional functions/macros that could help you configure Doom:
;;
;; - `load!' for loading external *.el files relative to this one
;; - `use-package!' for configuring packages
;; - `after!' for running code after a package has loaded
;; - `add-load-path!' for adding directories to the `load-path', relative to
;;   this file. Emacs searches the `load-path' when you load packages with
;;   `require' or `use-package'.
;; - `map!' for binding new keys
;;
;; To get information about any of these functions/macros, move the cursor over
;; the highlighted symbol at press 'K' (non-evil users must press 'C-c c k').
;; This will open documentation for it, including demos of how they are used.
;;
;; You can also try 'gd' (or 'C-c c d') to jump to their definition and see how
;; they are implemented.

(setq rfc-mode-directory (expand-file-name "~/rfc/"))

(setq org-noter-notes-search-path '("~/org/notes/"))

(setq org-odt-preferred-output-format "docx")

(require 'ob-plantuml)

(add-hook 'pdf-tools-enabled-hook 'pdf-view-midnight-minor-mode)

;; Custom key bindings to move between windows/splits
(after! evil
  (map! :leader
        :desc "winum-select-window-1"
        "1" #'winum-select-window-1)
  (map! :leader
        :desc "winum-select-window-2"
        "2" #'winum-select-window-2)
  (map! :leader
        :desc "winum-select-window-3"
        "3" #'winum-select-window-3)
  (map! :leader
        :desc "winum-select-window-4"
        "4" #'winum-select-window-4)
  (map! :leader
        :desc "winum-select-window-5"
        "5" #'winum-select-window-5)
  (map! :leader
        :desc "winum-select-window-6"
        "6" #'winum-select-window-6)
  (map! :leader
        :desc "winum-select-window-7"
        "7" #'winum-select-window-7)
  (map! :leader
        :desc "winum-select-window-8"
        "8" #'winum-select-window-8)
  (map! :leader
        :desc "winum-select-window-9"
        "9" #'winum-select-window-9))
